VERSION 0.8 # https://docs.earthly.dev/docs/earthfile#version
FROM python:3

ARG --global build_dir="out"


################
# Main targets #
################

{% include "./fragments/node.earth" %}

# Build the site
build:
    ARG yama_env="production"

    FROM +node-base
    WORKDIR /workdir

    # Persist build cache between builds (https://nextjs.org/docs/pages/building-your-application/deploying/ci-build-caching)
    CACHE .next/cache

    COPY . .


    # Uncomment if you wish to disable nextjs telemetry. Learn more at: https://nextjs.org/telemetry
    #ENV NEXT_TELEMETRY_DISABLED=1
    ENV YAMA_ENV=$yama_env


    # Assumes you have scripts in your package.json to run `next build`.
    # NOTE: "To enable a static export, change the output mode inside next.config.js".
    # See https://nextjs.org/docs/pages/building-your-application/deploying/static-exports
    RUN yarn run build

    SAVE ARTIFACT $build_dir build_result AS LOCAL $build_dir



##################
# Helper targets #
##################

{% include "./fragments/node-helpers.earth" %}

# Target that builds a production-ready Docker image, following Next.js's example:
# https://github.com/vercel/next.js/blob/canary/examples/with-docker/Dockerfile#L36
#
# NOTE: You must configure Next.js to output in "standalone" mode. Your `next.config.js` must look something like `module.exports = { output: 'standalone' }`.
# If you fail to do this, Earthly will crash with the message `Error: File not found "/.next/standalone"`.
#
# NOTE: This was last updated 2023-05-31. Things might have changed if you're reading this in the future!
# This example is only here to test and showcase Earthly's capabilities and isn't actually used or actively maintained by Yama-CMS. We use the "export" mode instead.
build-docker-image-prod:
    FROM node:lts-alpine
    ARG image_name="my-nextjs-server-image"
    WORKDIR /workdir
    ENV NODE_ENV production
    # Uncomment the following line in case you want to disable telemetry during runtime.
    # ENV NEXT_TELEMETRY_DISABLED 1
    RUN addgroup --system --gid 1001 nodejs
    RUN adduser --system --uid 1001 nextjs

    COPY +build/$build_dir ./public
    COPY +build/.next/standalone ./ # You must configure Next.js to standalone mode. See the note above.
    COPY +build/.next/static .next/static

    USER nextjs
    EXPOSE 3000
    ENV PORT 3000
    CMD ["node", "server.js"]

    # See https://docs.earthly.dev/docs/earthfile#save-image
    SAVE IMAGE $image_name

# Run `next dev` dev server with $PWD mounted. Run locally with `earthly +dev`.
# Note that if you exit Earthly (eg. via Ctrl+c), Earthly will immediately exit and leave the container running.
# You can manually stop it with `earthly +stop-dev` (or `docker stop earthly-dev-server`).
dev:
    ARG port=3000
    ARG container_name="earthly-dev-server"
    LOCALLY
        WITH DOCKER --load earthly-dev-server-image=+node-base
            RUN docker run --rm -i \
                        --volume="$PWD":/workdir:Z \
                        --publish $port:3000 \
                        --name="$container_name" \
                        earthly-dev-server-image \
                        yarn run dev
        END

stop-dev:
    ARG container_name="earthly-dev-server"

    LOCALLY
        RUN docker stop $container_name



################
# Swift upload #
################

{% include "./fragments/swift.earth" %}
